// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Gpgsv.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/gpgsv__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `message_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `satellites`
#include "novatel_gps_msgs/msg/detail/satellite__functions.h"

bool
novatel_gps_msgs__msg__Gpgsv__init(novatel_gps_msgs__msg__Gpgsv * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Gpgsv__fini(msg);
    return false;
  }
  // message_id
  if (!rosidl_runtime_c__String__init(&msg->message_id)) {
    novatel_gps_msgs__msg__Gpgsv__fini(msg);
    return false;
  }
  // n_msgs
  // msg_number
  // n_satellites
  // satellites
  if (!novatel_gps_msgs__msg__Satellite__Sequence__init(&msg->satellites, 0)) {
    novatel_gps_msgs__msg__Gpgsv__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__Gpgsv__fini(novatel_gps_msgs__msg__Gpgsv * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // message_id
  rosidl_runtime_c__String__fini(&msg->message_id);
  // n_msgs
  // msg_number
  // n_satellites
  // satellites
  novatel_gps_msgs__msg__Satellite__Sequence__fini(&msg->satellites);
}

novatel_gps_msgs__msg__Gpgsv *
novatel_gps_msgs__msg__Gpgsv__create()
{
  novatel_gps_msgs__msg__Gpgsv * msg = (novatel_gps_msgs__msg__Gpgsv *)malloc(sizeof(novatel_gps_msgs__msg__Gpgsv));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Gpgsv));
  bool success = novatel_gps_msgs__msg__Gpgsv__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Gpgsv__destroy(novatel_gps_msgs__msg__Gpgsv * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Gpgsv__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Gpgsv__Sequence__init(novatel_gps_msgs__msg__Gpgsv__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Gpgsv * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Gpgsv *)calloc(size, sizeof(novatel_gps_msgs__msg__Gpgsv));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Gpgsv__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Gpgsv__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Gpgsv__Sequence__fini(novatel_gps_msgs__msg__Gpgsv__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Gpgsv__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Gpgsv__Sequence *
novatel_gps_msgs__msg__Gpgsv__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Gpgsv__Sequence * array = (novatel_gps_msgs__msg__Gpgsv__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Gpgsv__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Gpgsv__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Gpgsv__Sequence__destroy(novatel_gps_msgs__msg__Gpgsv__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Gpgsv__Sequence__fini(array);
  }
  free(array);
}
