// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Insstdev.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/insstdev__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `novatel_msg_header`
#include "novatel_gps_msgs/msg/detail/novatel_message_header__functions.h"
// Member `extended_solution_status`
#include "novatel_gps_msgs/msg/detail/novatel_extended_solution_status__functions.h"

bool
novatel_gps_msgs__msg__Insstdev__init(novatel_gps_msgs__msg__Insstdev * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Insstdev__fini(msg);
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&msg->novatel_msg_header)) {
    novatel_gps_msgs__msg__Insstdev__fini(msg);
    return false;
  }
  // latitude_dev
  // longitude_dev
  // height_dev
  // north_velocity_dev
  // east_velocity_dev
  // up_velocity_dev
  // roll_dev
  // pitch_dev
  // azimuth_dev
  // extended_solution_status
  if (!novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__init(&msg->extended_solution_status)) {
    novatel_gps_msgs__msg__Insstdev__fini(msg);
    return false;
  }
  // time_since_update
  return true;
}

void
novatel_gps_msgs__msg__Insstdev__fini(novatel_gps_msgs__msg__Insstdev * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // novatel_msg_header
  novatel_gps_msgs__msg__NovatelMessageHeader__fini(&msg->novatel_msg_header);
  // latitude_dev
  // longitude_dev
  // height_dev
  // north_velocity_dev
  // east_velocity_dev
  // up_velocity_dev
  // roll_dev
  // pitch_dev
  // azimuth_dev
  // extended_solution_status
  novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__fini(&msg->extended_solution_status);
  // time_since_update
}

novatel_gps_msgs__msg__Insstdev *
novatel_gps_msgs__msg__Insstdev__create()
{
  novatel_gps_msgs__msg__Insstdev * msg = (novatel_gps_msgs__msg__Insstdev *)malloc(sizeof(novatel_gps_msgs__msg__Insstdev));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Insstdev));
  bool success = novatel_gps_msgs__msg__Insstdev__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Insstdev__destroy(novatel_gps_msgs__msg__Insstdev * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Insstdev__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Insstdev__Sequence__init(novatel_gps_msgs__msg__Insstdev__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Insstdev * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Insstdev *)calloc(size, sizeof(novatel_gps_msgs__msg__Insstdev));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Insstdev__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Insstdev__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Insstdev__Sequence__fini(novatel_gps_msgs__msg__Insstdev__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Insstdev__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Insstdev__Sequence *
novatel_gps_msgs__msg__Insstdev__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Insstdev__Sequence * array = (novatel_gps_msgs__msg__Insstdev__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Insstdev__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Insstdev__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Insstdev__Sequence__destroy(novatel_gps_msgs__msg__Insstdev__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Insstdev__Sequence__fini(array);
  }
  free(array);
}
