// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/NovatelReceiverStatus.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_receiver_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
novatel_gps_msgs__msg__NovatelReceiverStatus__init(novatel_gps_msgs__msg__NovatelReceiverStatus * msg)
{
  if (!msg) {
    return false;
  }
  // original_status_code
  // error_flag
  // temperature_flag
  // voltage_supply_flag
  // antenna_powered
  // antenna_is_open
  // antenna_is_shorted
  // cpu_overload_flag
  // com1_buffer_overrun
  // com2_buffer_overrun
  // com3_buffer_overrun
  // usb_buffer_overrun
  // rf1_agc_flag
  // rf2_agc_flag
  // almanac_flag
  // position_solution_flag
  // position_fixed_flag
  // clock_steering_status_enabled
  // clock_model_flag
  // oemv_external_oscillator_flag
  // software_resource_flag
  // aux1_status_event_flag
  // aux2_status_event_flag
  // aux3_status_event_flag
  return true;
}

void
novatel_gps_msgs__msg__NovatelReceiverStatus__fini(novatel_gps_msgs__msg__NovatelReceiverStatus * msg)
{
  if (!msg) {
    return;
  }
  // original_status_code
  // error_flag
  // temperature_flag
  // voltage_supply_flag
  // antenna_powered
  // antenna_is_open
  // antenna_is_shorted
  // cpu_overload_flag
  // com1_buffer_overrun
  // com2_buffer_overrun
  // com3_buffer_overrun
  // usb_buffer_overrun
  // rf1_agc_flag
  // rf2_agc_flag
  // almanac_flag
  // position_solution_flag
  // position_fixed_flag
  // clock_steering_status_enabled
  // clock_model_flag
  // oemv_external_oscillator_flag
  // software_resource_flag
  // aux1_status_event_flag
  // aux2_status_event_flag
  // aux3_status_event_flag
}

novatel_gps_msgs__msg__NovatelReceiverStatus *
novatel_gps_msgs__msg__NovatelReceiverStatus__create()
{
  novatel_gps_msgs__msg__NovatelReceiverStatus * msg = (novatel_gps_msgs__msg__NovatelReceiverStatus *)malloc(sizeof(novatel_gps_msgs__msg__NovatelReceiverStatus));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__NovatelReceiverStatus));
  bool success = novatel_gps_msgs__msg__NovatelReceiverStatus__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__NovatelReceiverStatus__destroy(novatel_gps_msgs__msg__NovatelReceiverStatus * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__NovatelReceiverStatus__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__init(novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__NovatelReceiverStatus * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__NovatelReceiverStatus *)calloc(size, sizeof(novatel_gps_msgs__msg__NovatelReceiverStatus));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__NovatelReceiverStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__NovatelReceiverStatus__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__fini(novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__NovatelReceiverStatus__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence *
novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence * array = (novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__destroy(novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__NovatelReceiverStatus__Sequence__fini(array);
  }
  free(array);
}
